# DomoticX Virtual 3D Device Port SU15 interface.

# Wat moet er gebeuren bij het starten van de simulatie?
onstart{
  compoortopties = ["Seriele poort:", "Baudrate:"]
  # Standaard waarden!, deze kun je zelf aanpassen!
  standaard = ["COM8", "9600"]
  # Lijst met baudrates voor de dropdownlijst in het menu.
  baudratelijst = ["", "4800|9600|14400|19200|28800|38400|57600|115200"]
  # Geef het dialoogvenster weer voor vraag naar gegevens.
  serialsettings = UI.inputbox(compoortopties, standaard, baudratelijst, "Seriele poort instellingen:")

  if serialsettings != FALSE
    # Haal de instellingen uit het diagloogvenster en koppel deze aan een variabele.
    $comport = serialsettings[0]
    $baudrate = serialsettings[1].to_i

    begin
      # Open de seriele poort.
      @serial = Serial.new($comport, $baudrate)
    rescue RubySerial::Exception => e
      # Sluit de seriele poort als deze open staat.
      @serial.close if @serial
      # Reset/stop de simulatie.
      MSketchyPhysics3::SketchyPhysicsClient.physicsReset
      # Geef een bericht dat de seriele poort niet is gevonden.
      UI.messagebox("Seriele poort niet gevonden!")
    end
  else
    # Reset/stop de simulatie.
    MSketchyPhysics3::SketchyPhysicsClient.physicsReset
  end
}

# Wat moet er gebeuren tijdens de simulatie?
ontick{
  # Sluit het 'control panel' venster bij het starten van de simulatie.
  MSketchyPhysics3.closeControlPanel if frame == 1

  # Lees de data van de seriele poort in.
  $serialdata = @serial.read(1024)

  # Geef de gegevens weer aan de linker zijde (log).
  logLine("COM poort: " + $comport.to_s)
  logLine("BAUD rate: " + $baudrate.to_s)
  logLine("Seriele data: " + $serialdata.to_s)
  logLine("")
  logLine("")
  logLine("")
  logLine("")
  logLine("")
}

# Wat moet er gebeuren als de de simulatie stopt?
onend{
  # Sluit de seriele poort als deze open staat.
  @serial.close if @serial
}